<template>
  <div style="display: flex; justify-content: space-between;">
    <div style="text-align: left">
      <label>Отчет: </label>
      <select v-model="selectedReport">
        <option v-for="item in reportList" :key="item">{{item}}</option>
      </select>
    <button @click="run()">Выполнить</button>      
    <button @click="saveTextClipBoard()">Копировать</button>
    </div>
  </div>
  <div>
    <label>Параметры   c</label>
    <flat-pickr v-model="dateStart"></flat-pickr>
    <label>по</label>
    <flat-pickr v-model="dateFinish"></flat-pickr>
  </div>

  <!--
  <div style="display: flex; justify-content: space-between;">
    <div style="text-align: left">
      <label>БД:</label>
      <input v-model="q1" />
      <input v-model="q2" />
      <input v-model="q3" />
    </div>
  </div>
-->
  <div style="display: flex; justify-content: space-between;">
    <div style="text-align: left">
      <label>Фильтры: </label>
      <input v-model="searchTerm1" />
      <input v-model="searchTerm2" />
      <input v-model="searchTerm3" />
    </div>
  </div>
  <table-lite
    :is-static-mode=true
    :columns="table.columns"
    :rows="table.rows"
    :total="table.totalRecordCount"
    :messages="table.messages"
    :page="page"
    :page-size="pageSize"
    @get-now-page="setCurrentPage" 
    @get-now-page-size="setCurrentPageSize" 
    @is-finished="tableLoadingFinish"    
    >
  </table-lite>

  <loader :active="loaderActive" message="Загрузка данных" />  

  <div v-for="item in images" v-bind:key="item.name">
    <div style="display: flex; justify-content: space-between;">
      <label>{{item.name}}</label>
      <div>
        <label style="font-weight:bold">Cloud</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label >{{item.Cloud}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Water</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Water}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Snow</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Snow}}</label>
      </div>
       <div>
        <label style="font-weight:bold">Defects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Defects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">DDefects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.DDefects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Shadows</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Shadows}}</label>
      </div>
      <div>
        <label style="font-weight:bold">StitchingMs</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.StitchingMs}}</label>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.productQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.routeQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.summaryQualityStatus}}</a>
      </div>
    </div>   
   
    <a rel="nofollow" :href="item.rpath">
      <img :src="item.rpath" style="width:100%;"/>
      <p></p>
    </a>
  </div>

  <div v-if="moreImages">
    <div>
      <button @click="drawImages()">Показать {{maxImages}} продуктов</button>  
    </div>  
  </div>

</template>

<script>
import { defineComponent, reactive, ref, computed, watch } from "vue"
import axios from 'axios'
import flatPickr from 'vue-flatpickr-component';
import 'flatpickr/dist/flatpickr.css';

import TableLite from "../components/TableLite"
import { redouteProvider } from  "../config/provider"
import Loader from '../components/Loader.vue'
import router from "../router/index.ts"
import * as helper from './helper.js'

var storePage = 1
var storePageSize = 20

var searchTerm1 = ref('')
var searchTerm2 = ref('')
var searchTerm3 = ref('')
var q1 = ref('')  
var q2 = ref('')
var q3 = ref('')
var reportName = ref('quality')
var reportList = reactive([])
var selectedReport = ref('')
var pageSize = ref('20')
var startIndexImage = ref(0)
var maxImages = ref(50)
var moreImages = ref(false)

const images = reactive([])

// собственно табличные данные 
// храним в глобальнй области, чтобы не было удаления при переходе между страницами
const data = reactive([]);
// Table config
const table = reactive({
  columns: [],
  rows: computed(() => {
    return data.filter(
      (x) => {
        let fields = []
        table.columns.forEach(element => {
          fields.push(x[element.field])              
        });
        let nameFilter = helper.ok(fields,searchTerm1.value) && helper.ok(fields,searchTerm2.value) && helper.ok(fields,searchTerm3.value)
        return nameFilter
      }
    );
  }),
  totalRecordCount: computed(() => {
    return table.rows.length;
  }),
  messages: {
    pagingInfo: "{0}-{1}/{2}",
    pageSizeChangeLabel: "Строк:",
    gotoPageLabel: "Перейти:",
    noDataAvailable: "",
  },      
});

function updateData(response, data, table) {
  if (!Array.isArray(response.data)) {
    data.splice(0,data.length)
    table.messages.noDataAvailable = response.data
    return
  }
  table.messages.noDataAvailable = "Нет данных" 
  table.columns.length = 0
  data.splice(0,data.length)
  images.splice(0,images.length)  
  startIndexImage.value = 0
  moreImages.value = true

  if (response.data.length == 0) return
  // добавляем названия колонок по именам объектов из первой строки
  let col = response.data[0]
  for (let p in col) {
    let c = {
       label:  p,
       field:  p, 
      }
    if (p == 'product') c.display = function (row) {
            return (
              '<a href="javascript:void(0)" data-id="' +
              row.product + 
              '" class="is-rows-el job-btn">' +
              row.product +
              "</a>"
            )
          }
    table.columns.push(c)
  }
  response.data.forEach(element => data.push(element) )   
}

export default defineComponent({ 
  name: "App",
  components: { TableLite, Loader,  flatPickr },
  setup() {

    const dateStart = ref(new Date())
    const dateFinish = ref(new Date())
    const pageSize = ref('')
    const page = ref("")
    page.value = storePage
    pageSize.value = storePageSize
    const maxQL = ref('50')

    if (reportList.length == 0) init()

    watch(selectedReport, () =>  {
      load()
    })

    const loaderActive = ref(false)

    const setCurrentPage = (pageNumber) => {
        storePage = pageNumber
    };

    const setCurrentPageSize = (pageSize) => {
        storePageSize = pageSize.value
    };

    const tableLoadingFinish = (elements) => {
      table.isLoading = false;
      Array.prototype.forEach.call(elements, function (element) {
        if (element.classList.contains("job-btn")) {
          element.addEventListener("click", function () {
            goToJob2(this.dataset.id)
          });
        }
      });    
    }

    function goToJob2 (id) {
      // в строке хранятся 3 числа через запятую task,job,product
      let part = id.split(',')
      router.push({ path: '/job2', query: { product_id: part[0] } })
    }
    
    async function init() {
      const url = redouteProvider + '/report'
      let postData = { action: "list" }
      let sPost = JSON.stringify(postData)

      reportList.splice(0,reportList.length)
      let response = await axios.post(url, sPost);
      response.data.forEach(element => reportList.push(element) )   
    }

    function load() {
      const url = redouteProvider + '/report'

      // при выборе отчета даем возможность визуализировать параметры на странице
      let postData = { name: selectedReport.value, action: "param"  }
      axios.post(url, JSON.stringify(postData))
        .then(response => { 
          alert('load')
        })
        .catch(error => { alert(error); })
    }


    function run() {
      const url = redouteProvider + '/report'

      // выполняем
      let postData = { name: selectedReport.value, action: "run"  }
      loaderActive.value = true
      axios.post(url, JSON.stringify(postData))
        .then(response => { updateData(response,data,table); loaderActive.value = false; } )
        .catch(error => { alert(error); loaderActive.value = false; })
    }

    function saveTextClipBoard()  {
      let ret = ''
      let rows = table.rows;
      for (let row of rows) {
        for (let item in row) {
          ret += row[item] + '\t'
        }
        ret += '\n'
      }
      helper.copyToClipboard(ret)
    }

    function drawImages()   {

      loaderActive.value = true

      //images.splice(0,images.length)   
      let rows = table.rows;
      let productList = []
      for (let i=startIndexImage.value; i<startIndexImage.value+maxImages.value; i++) {
        if (i >= rows.length) { moreImages.value = false; break; }
        let row = rows[i]
        let productId = row.product
        if (!productId) continue
        productList.push(productId)
      }

      let request = redouteProvider + '/images'
      let postData = {productList: productList}

      axios.post(request, JSON.stringify(postData))
      .then(response => { 
        if (response.data && response.data.length > 0) {
          response.data.forEach(element => {
            element.rpath = redouteProvider+'/image?' + 'name=' + element.path
            element.qarpath = redouteProvider+'/file?' + 'name=' + element.qa
            images.push(element)
          })
          startIndexImage.value += maxImages.value
          loaderActive.value = false;
        }
      })
      .catch(error => { 
        //table.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
        images.push({name:error})
        loaderActive.value = false;
      })
    }

    return {
      table,
      load, run,
      loaderActive,
      reportName,
      tableLoadingFinish,
      searchTerm1,searchTerm2,searchTerm3,
      q1,q2,q3,
      page, pageSize,
      setCurrentPage, setCurrentPageSize,
      reportList, selectedReport,
      saveTextClipBoard,
      drawImages,
      images, maxQL, 
      startIndexImage, moreImages, maxImages,
      dateStart, dateFinish,
    };
  },
});


</script>


<style scoped>

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.1rem;
    font-size: smaller;
  }

  </style>

